/* -----------------------------------------------------------------------------*/
/*                              MQSeries Everyplace                             */
/*                                                                              */
/* Licensed Materials - Property of IBM                                         */
/*                                                                              */
/* 5639-I47                                                                     */
/*                                                                              */
/* (C) Copyright IBM Corp. 1999                                                 */
/* -----------------------------------------------------------------------------*/
/** @@HEADER_H_INC */
#ifndef HMQHELPER_H_INCLUDED

#define PMQETCHAR MQETCHAR*

/**
     MQeFields Core APIs
 */

#define MQeFieldsContains( hSess, hFlds, pName, pCompCode, pReason) \
        (MQeFieldsGet( (hSess), (hFlds), (pName), (NULL), (NULL), 0, 0, (pCompCode), (pReason))>0)

#define MQeFieldsPutArrayOfByte( hSess, hFlds, pName, pData, n, pCompCode, pReason) \
        MQeFieldsPut( (hSess), (hFlds), (pName), MQE_TYPE_BYTE, (pData), n, (pCompCode), (pReason))

#define MQeFieldsPutArrayOfShort( hSess, hFlds, pName, pData, n, pCompCode, pReason) \
        MQeFieldsPut( (hSess), (hFlds), (pName), MQE_TYPE_SHORT, (pData), n, (pCompCode), (pReason))

#define MQeFieldsPutArrayOfInt( hSess, hFlds, pName, pData, n, pCompCode, pReason) \
        MQeFieldsPut( (hSess), hFlds, pName, MQE_TYPE_INT, (pData), n, (pCompCode), (pReason))

#define MQeFieldsPutArrayOfLong( hSess, hFlds, pName, pData, n, pCompCode, pReason) \
        MQeFieldsPut( (hSess), (hFlds), (pName), MQE_TYPE_LONG, (pData), n, (pCompCode), (pReason))

#define MQeFieldsPutArrayOfFloat( hSess, hFlds, pName, pData, n, pCompCode, pReason) \
        MQeFieldsPut( (hSess), (hFlds), (pName), MQE_TYPE_FLOAT, (pData), n, (pCompCode), (pReason))

#define MQeFieldsPutArrayOfDouble( hSess, hFlds, pName, pData, n, pCompCode, pReason) \
        MQeFieldsPut( (hSess), (hFlds), (pName), MQE_TYPE_DOUBLE, (pData), n, (pCompCode), (pReason))

#define MQeFieldsPutAscii( hSess, hFlds, pName, pStr, StrLen, pCompCode, pReason) \
        MQeFieldsPut( (hSess), (hFlds), (pName), MQE_TYPE_ASCII, pStr, StrLen, (pCompCode), (pReason))

#define MQeFieldsPutBoolean( hSess, hFlds, pName, aBool, pCompCode, pReason) \
        MQeFieldsPut( (hSess), (hFlds), (pName), MQE_TYPE_BOOLEAN, aBool, 1, (pCompCode), (pReason))

#define MQeFieldsPutFields( hSess, hFlds1, pName, hFlds2, pCompCode, pReason) \
        MQeFieldsPut( (hSess), (hFlds1), (pName), (MQE_TYPE_FIELDS), (&hFlds2), (1), (pCompCode), (pReason))

#define MQeFieldsPutByte( hSess, hFlds, pName, aByte, pCompCode, pReason) \
        MQeFieldsPut( (hSess), (hFlds), (pName), MQE_TYPE_BYTE, aByte, 1, (pCompCode), (pReason))

#define MQeFieldsPutShort( hSess, hFlds, pName, aShort, pCompCode, pReason) \
        MQeFieldsPut( (hSess), (hFlds), (pName), MQE_TYPE_SHORT, aShort, 1, (pCompCode), (pReason))
                     
#define MQeFieldsPutInt( hSess, hFlds, pName, anInt , pCompCode, pReason) \
        MQeFieldsPut( (hSess), (hFlds), (pName), MQE_TYPE_INT, anInt, 1, (pCompCode), (pReason))

#define MQeFieldsPutLong( hSess, hFlds, pName, aLong , pCompCode, pReason) \
        MQeFieldsPut( (hSess), (hFlds), (pName), MQE_TYPE_LONG, aLong, 1, (pCompCode), (pReason))

#define MQeFieldsPutFloat( hSess, hFlds, pName, aFloat, pCompCode, pReason) \
        MQeFieldsPut( (hSess), (hFlds), (pName), MQE_TYPE_FLOAT, aFloat, 1, (pCompCode), (pReason))

#define MQeFieldsPutDouble( hSess, hFlds, pName, aDouble , pCompCode, pReason) \
        MQeFieldsPut( (hSess), (hFlds), (pName), MQE_TYPE_DOUBLE, aDouble, 1, (pCompCode), (pReason))

#define MQeFieldsPutUnicode( hSess, hFlds, pName, pTStr, TStrLen, pCompCode, pReason) \
        MQeFieldsPut( (hSess), (hFlds), (pName), MQE_TYPE_UNICODE, (pTStr), (TStrLen), (pCompCode), (pReason))

extern MQEINT32 MQeFieldsCopy           ( MQEHSESS, MQEHFIELDS, MQEHFIELDS, MQEINT32,    PMQECHAR,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsDataLength     ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEINT32 *,  MQEINT32 * );
extern MQEBYTE  MQeFieldsDataType       ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEINT32 *,  MQEINT32 * );
extern MQEINT32 MQeFieldsGetArrayLength ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEINT32 *,  MQEINT32 * );
extern MQEINT32 MQeFieldsGetArrayOfByte ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEBYTE * ,  MQEINT32,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsGetArrayOfShort( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEINT16*,   MQEINT32,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsGetArrayOfInt  ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEINT32 *,  MQEINT32,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsGetArrayOfLong ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEINT64 *,  MQEINT32,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsGetArrayOfFloat( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEFLOAT * , MQEINT32,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsGetArrayOfDouble(MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEDOUBLE *, MQEINT32,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsGetAscii       ( MQEHSESS, MQEHFIELDS, PMQECHAR,   PMQECHAR,    MQEINT32,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsGetAsciiArray  ( MQEHSESS, MQEHFIELDS, PMQECHAR,   PMQECHAR *,  MQEINT32 *, MQEINT32,   MQEINT32,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsGetBoolean     ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEBYTE *,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsGetByte        ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEBYTE *,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsGetShort       ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEINT16*,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsGetInt         ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEINT32 *,  MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsGetLong        ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEINT64 *,  MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsGetFloat       ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEFLOAT *,  MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsGetDouble      ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEDOUBLE *, MQEINT32 *, MQEINT32 * );
extern MQEHFIELDS MQeFieldsGetFields    ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEINT32 *,  MQEINT32 * );  
extern MQEINT32 MQeFieldsGetByteArray   ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEBYTE **,  MQEINT32 *,   MQEINT32, MQEINT32, MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsGetShortArray  ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEINT16 *,  MQEINT32,   MQEINT32,  MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsGetIntArray    ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEINT32 *,  MQEINT32,   MQEINT32,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsGetLongArray   ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEINT64 *,  MQEINT32,   MQEINT32,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsGetFloatArray  ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEFLOAT *,  MQEINT32,   MQEINT32,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsGetDoubleArray ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEDOUBLE *, MQEINT32,   MQEINT32,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsGetObject      ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEBYTE *,   MQEINT32,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsGetUnicode     ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEINT16 *,  MQEINT32,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsGetUnicodeArray( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEINT16 **, MQEINT32 *, MQEINT32,   MQEINT32, MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsPutAsciiArray  ( MQEHSESS, MQEHFIELDS, PMQECHAR,   PMQECHAR *,  MQEINT32 *, MQEINT32,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsPutByteArray   ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEBYTE **,  MQEINT32 *,  MQEINT32,  MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsPutShortArray  ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEINT16 *,  MQEINT32,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsPutIntArray    ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEINT32 *,  MQEINT32,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsPutLongArray   ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEINT64 *,  MQEINT32,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsPutFloatArray  ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEFLOAT * , MQEINT32,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsPutDoubleArray ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEDOUBLE *, MQEINT32,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsPutUnicodeArray( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEINT16 **, MQEINT32 *, MQEINT32,   MQEINT32 *, MQEINT32 * );
extern MQEINT32 MQeFieldsPutArrayLength ( MQEHSESS, MQEHFIELDS, PMQECHAR,   MQEINT32,  MQEINT32 *, MQEINT32 *);

#define HMQHELPER_H_INCLUDED 1


#endif
